VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form frm1 
   Caption         =   "TreeView and ListView Drag-N-Drop"
   ClientHeight    =   3135
   ClientLeft      =   1245
   ClientTop       =   1845
   ClientWidth     =   6585
   LinkTopic       =   "Form1"
   ScaleHeight     =   3135
   ScaleWidth      =   6585
   StartUpPosition =   2  'CenterScreen
   Begin MSComctlLib.ListView ListView1 
      Height          =   2730
      Left            =   360
      TabIndex        =   1
      Top             =   240
      Width           =   2625
      _ExtentX        =   4630
      _ExtentY        =   4815
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   0
   End
   Begin MSComctlLib.TreeView TreeView1 
      Height          =   2760
      Left            =   3240
      TabIndex        =   0
      Top             =   240
      Width           =   3045
      _ExtentX        =   5371
      _ExtentY        =   4868
      _Version        =   393217
      LineStyle       =   1
      Style           =   7
      Appearance      =   1
      OLEDragMode     =   1
      OLEDropMode     =   1
   End
End
Attribute VB_Name = "frm1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim li2 As ListItem
Dim moDragNode As Node

Private Sub Form_Load()

'    NOTE: ******************
'    Please make sure that the following properties are set accordingly
'    With ListView1
'        .OLEDragMode = ccOLEDragManual
'        .OLEDropMode = ccOLEDropNone
'    End With
'    With TreeView1
'        .LineStyle = tvwRootLines
'        .OLEDragMode = ccOLEDragAutomatic
'        .OLEDropMode = ccOLEDropManual
'    End With

    Dim str As String
    Dim cnt, k As Integer
    Dim Li As ListItem      ' Declare List item variable.
    Dim nodX As Node        ' Declare Node variable.
    
    ' Populating the Listview control
    Set Li = ListView1.ListItems.Add(, , "Item1")
    Set Li = ListView1.ListItems.Add(, , "Item2")
    Set Li = ListView1.ListItems.Add(, , "Item3")
    
    ListView1.View = lvwList
    
    'Populating the tree control
    ' First node with 'Root' as text.
    For cnt = 1 To 2
        Set nodX = TreeView1.Nodes.Add(, , "r" & cnt, "Root" & cnt)
    Next
    
    ' This next node is a child of Node 1 ("r").
    For k = 1 To 2
        str = "r" & k
        For cnt = 1 To 5
             Set nodX = TreeView1.Nodes.Add(str, tvwChild, "child" & k & cnt, "Child" & k & cnt)
        Next
    Next
    
    TreeView1.Nodes(1).Selected = True
    TreeView1.Nodes(1).Expanded = True
    
End Sub

Private Sub ListView1_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
   Set ListView1.SelectedItem = ListView1.HitTest(x, y)
   
   ' In the following line any ICO file will do
   ListView1.DragIcon = LoadPicture(AppPath & "HelloSir.ICO")
   
   ListView1.Drag vbBeginDrag
End Sub


Private Sub TreeView1_DragDrop(Source As Control, x As Single, y As Single)

    Set li2 = ListView1.SelectedItem
    If li2 Is Nothing Then Exit Sub
    Dim TN As Node
    
'    Check if any itme in the treeview is highlighted or selected
    If TreeView1.DropHighlight Is Nothing Then
        Set TreeView1.DropHighlight = TreeView1.HitTest(x, y)
        TreeView1.SelectedItem = TreeView1.DropHighlight
        
        If TreeView1.SelectedItem Is Nothing Then
        
'            If no item is selected, then place the list item
'            as root node.
        
            Set TN = TreeView1.Nodes.Add(, , li2.Key, li2.Text)
        
        Else
        
'            If any itme is selected, then place the list item
'            as its Child node
        
            Set moDragNode = TreeView1.SelectedItem
        
            Set TN = TreeView1.Nodes.Add(moDragNode, tvwChild, li2.Key, li2.Text)
        
        End If
        
    End If
    
    Set TreeView1.DropHighlight = Nothing
    
End Sub

Private Function AppPath() As String
    
    Dim sAns As String
    sAns = App.Path
    If Right(App.Path, 1) <> "\" Then sAns = sAns & "\"
    AppPath = sAns

End Function
